# Base Domain Inverse Function

This module provides functions to decompose normalized domains into domains operands, as these functions are the inverse of AND and OR functions available in odoo.osv.expression.

Important

This is an alpha version, the data model and design can change at any time without warning. Only for development or testing purpose, do not use in production. More details on development status

Table of contents

- Usage
- Known issues / Roadmap
- Bug Tracker
- Credits
  - Authors
  - Contributors
  - Other credits
  - Maintainers

# Usage

If you have to decompose a complex domain to inject some conditions, this shows what you can do:

    from odoo.osv.expression import AND, OR
    from odoo.addons.base_domain_inverse_function.expression import inverse_AND, inverse_OR

    domain = AND([d1, d2, d3])
    d1, d2, d3 = inverse_AND(domain)

    domain = OR([d1, d2, d3])
    d1, d2, d3 = inverse_OR(domain)

# Known issues / Roadmap

- Allow to inverse domains containing NOT ‘!’ operator

# Bug Tracker

Bugs are tracked on GitHub Issues. In case of trouble, please check there if your issue has already been reported. If you spotted it first, help us to smash it by providing a detailed and welcomed feedback.

Do not contact contributors directly about support or help with technical issues.

# Credits

## Authors

- Camptocamp

## Contributors

- Akim Juillerat <akim.juillerat@camptocamp.com>

- Trobz:

  > - Son Ho <sonhd@trobz.com>

## Other credits

The migration of this module from 13.0 to 16.0 was financially supported by Camptocamp

## Maintainers

This module is maintained by the OCA.

OCA, or the Odoo Community Association, is a nonprofit organization whose mission is to support the collaborative development of Odoo features and promote its widespread use.

Current maintainer:

This module is part of the OCA/server-tools project on GitHub.

You are welcome to contribute. To learn how please visit https://odoo-community.org/page/Contribute.